inherit kernel
require recipes-kernel/linux/linux.inc

DESCRIPTION = "Linux kernel for Embedian SMARC T335X Computer on Modules"
KERNEL_IMAGETYPE = "zImage"
COMPATIBLE_MACHINE = "smarct335x"
DEFAULT_PREFERENCE = "-1"

S = "${WORKDIR}/git"

# Stage the power management firmware before building the kernel
DEPENDS += "am33x-cm3"

BRANCH  = "v3.2_SMARCT335xPSP_04.06.00.11"
#SRCREV = "${AUTOREV}"
# For rev. 00A0, uncomment out the following line.
#SRCREV = "5f08c606d2990bd6b45c5202e9ce6cf36143d84e"

# For rev. 00B0
SRCREV = "9f30bfb78dfd09b47c4a1dd9b59282812319792c"

SRC_URI = "git://git@git.embedian.com/developer/linux-smarc-t335x-v3.2.git;protocol=ssh;branch=${BRANCH} \
	file://defconfig \
"


PV = "3.2"
MACHINE_KERNEL_PR_append = "c+gitr${SRCPV}"

# UNCOMMENT FOR VERBOSE BUILD OUTPUT: EXTRA_OEMAKE += "V=1"

# Copy the am33x-cm3 firmware if it is available
do_configure_append() {
    if [ -e "${STAGING_DIR_HOST}/${base_libdir}/firmware/am335x-pm-firmware.bin" ]
    then
        cp "${STAGING_DIR_HOST}/${base_libdir}/firmware/am335x-pm-firmware.bin" "${S}/firmware"
    fi
}
